/**
 * Configuration properties for color, shape and size legend.
 *
 * @public
 * @module LegendConfig
 *
 * @param {boolean} show Whether to show or hide the legend.
 * @param {string} borderColor Border color of legend box.
 * @param {Object} marker Legend marker configuration
 * @param {Object} marker.text Legend marker text configuration.
 * @param {string} marker.text.formatter Returns formatted marker text value.
 * @param {Object} item Legend item configuration
 * @param {Object} item.text Legend item text configuration.
 * @param {number} item.text.width Item text width.
 * @param {string} item.text.orientation Text orientation of item text.
 * @param {string} item.text.formatter Returns formatted item text value.
 * @param {Object} item.icon Legend icon configuration.
 * @param {string} item.icon.type Type of icon.
 * Supported values are:- ['circle', 'diamond', 'star', 'cross', 'square', 'wye', 'triangle']
 * @param {number} item.icon.width Width of icon.
 * @param {number} item.icon.height Height of icon.
 * @param {string} item.icon.color Color of icon.
 */
